from django.conf.urls import url

from . import views


urlpatterns = [
    url(r'^$', views.user, name='user'),
    url(r'^asso/(?P<pk>[0-9]+)/$', views.corporation, name='corporation'),
    url(r'^users/$', views.UserList.as_view(), name='user-list'),
    url(r'^users/add/$', views.user_edit, name='user-add'),
    url(r'^users/(?P<pk>[0-9]+)/$', views.UserDetail.as_view(), name='user-detail'),
    url(r'^users/(?P<pk>[0-9]+)/edit/$', views.user_edit, name='user-edit'),
    url(r'^corporations/$', views.CorporationList.as_view(), name='corporation-list'),
    url(r'^corporations/add/$', views.CorporationCreate.as_view(), name='corporation-add'),
    url(r'^corporations/(?P<pk>[0-9]+)/', views.CorporationDetail.as_view(), name='corporation-detail'),
    url(r'^corporations/(?P<pk>[0-9]+)/edit/', views.CorporationUpdate.as_view(), name='corporation-edit'),
    url(r'^adhesions/$', views.AdhesionList.as_view(), name='adhesion-list'),
    url(r'^adhesions/(?P<pk>[0-9]+)/$', views.AdhesionDetail.as_view(), name='adhesion-detail'),
]
